open Util

open Format

open Kernel

let has_warning = ref false

let mk range =
  has_warning := true;
  kfprintf begin fun _ ->
    Pos.print_range stderr range;
    prerr_string "Warning. ";
    prerr_endline (flush_str_formatter ())
  end str_formatter

let redundent_constraint range =
  mk range "Redundent constraint."

let variable_introduced_twice range x =
  mk range "Variable %s is introduced twice." x

let unused_variables range list =
  match list with
    | [x] -> mk range "Unused variable: %s" x
    | _ -> mk range "Unused variables: %a" (List.format " " Var.format) list

let token_never_consumed range sgn =
  mk range "Token %s/%d never consumed." sgn.Sgn.f sgn.Sgn.arity
